<?php // doc_carousel.php

function div_carousel_thumb($i,&$imagefiles,$curr,$display=TRUE)
{
  global $options;
  $len=count($imagefiles);
  $im=$imagefiles[$i];

  $dt=date($options->date_format,$im->date_time());
  $nc=$im->numcomments('<span id="nc_'.$i.'" class="num_comments">%s</span>');
  ?>

    <div id="img_<?php echo $i;
         ?>" class="thumb<?php if($i==$curr) echo ' here';
                                if($i==$len-1) echo ' img_last';
         ?>"<?php if(!$display) echo ' style="display:none"';
         ?>>
     <a onclick="return go(this)" href="<?php
       echo '?d=c&amp;img=' . $i
       ?>"><img <?php $ir=$im->square(); $ir->ehtml() ?> /></a>
     <div>
      <h3><?php echo nice($im->name) ?></h3>
      <p id="dtc_<?php echo $i ?>"><?php echo $nc ?><span class="date_time"><?php echo $dt ?></span></p>
      <p id="cap_<?php echo $i ?>"><?php echo $im->short_caption() ?></p>
     </div>
    </div>

  <?php
  flush();
}


/** Emits a <P> containing the caption for this image, if it has one.
 *  The administrator also sees the controls to add of edit the caption. */
function para_caption(&$imagefile,$img)
{
  global $is_admin;
  $caption=$imagefile->caption();
  if($is_admin): ?>
  
    <p id="cap_para" class="caption">
     <span id="caption"><?php echo str_replace("\n",'<br />',$caption) ?></span>
     <a id="cap_ctrl" class="control" onclick="return do_show_caption_editor()"
      href="?d=c&amp;img=<?php echo $img ?>">
      <?php echo ($caption)? 'edit': 'add caption' ?>
     </a>
    </p>
    
    <form id="cap_form" class="caption" style="display:none" name="cap_form" method="POST" action="?d=x&img=<?php echo $img ?>">
     <input type="hidden" name="do" value="editcaption" />
     <textarea id="cap_txt" name="cap_txt"><?php echo $caption ?></textarea>
     <input type="submit" id="cap_sub" value="Save" title="Save Caption" onclick="return do_save_caption()" />
     <?php echo img_load('cap_busy') ?>
    </form>
  
  <?php elseif($caption): ?>

    <p class="caption"><?php echo $caption ?></p>

  <?php endif;
}


function div_comments(&$imagefile)
{
  global $img,$options,$is_admin;
  $comments=$imagefile->comments();
  echo '<div id="comments">'."\n";
  if($comments)
  {
    echo '<h2 id="cmt_head">Comments</h2>'."\n";
    foreach($comments as $c)
    {
      global $options;
      echo '<div class="comment" id="'.$c->id.'">'."\n";
      echo '<p>'.$c->text."</p>\n";
      echo '<p class="by">posted by <span class="author">'.$c->author
          .'</span> on '.date($options->date_format,$c->time);
      if($is_admin)
        echo ' <a class="control" onclick="return do_delete_comment(this)" href=".">delete</a>';
      echo '</p></div>'."\n";
    }
  }
  else
  {
    echo '<h2 id="cmt_head" style="display:none">Comments</h2>'."\n";
  } ?>

  <form id="cmt_form" class="comment" name="cmt_form" style="display:none" method="POST" action="?d=x&img=<?php echo $img ?>">
   <h2>Leave a Comment</h2>
   <input type="hidden" name="do" value="addcomment" />
   <input type="text" id="cmt_author" name="cmt_author" />
   <label for="cmt_author">Name</label><br />
   <textarea id="cmt_txt" name="cmt_txt"></textarea><br />
   <input type="submit" id="cmt_sub" value="Submit" title="Submit Comment" onclick="return do_submit_comment()" />
   <?php echo img_load('cmt_busy') ?>
  </form>
  <p class="comment"><!--
   --><a id="cmt_ctrl" class="control" onclick="return do_show_comment_editor()" href="?d=c&amp;img=<?php echo $img
    ?>">Leave a Comment</a></p>

  <?php echo "</div>\n";
}


function doc_carousel(&$imagefiles)
{
  global $dirs,$img,$options;

  $len=count($imagefiles);
  $pos=intval($_POST['pos']);

  $carousel_size=min($len,6); // Number of images in the carousel.

  if(array_key_exists('pos',$_POST))
  {
    // Scroll the carousel around with the image.
    if($pos==$img)
       $pos=$img-1;
    else if(normalize($pos+$carousel_size-1,$len) == $img)
       $pos=$img+2-$carousel_size;
  }
  else
  {
    // Centre the image in the carousel...
    $pos=$img-intval(($carousel_size-0.5)/2);
    // ...but start at the beginning, end at the end.
    if($pos+$carousel_size-1 >= $len)
       $pos=$len-$carousel_size;
    else if($pos < 0)
       $pos=0;
  }
  $pos=normalize($pos,$len);

  $title=nice($imagefiles[$img]->name);
  $album=$dirs->current_album_title();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title><?php echo $title.' &laquo; '.hsc($dirs->path()) ?></title>
<link rel="stylesheet" href="<?php echo get_file('exa.css') ?>" type="text/css" />
<?php load_theme() ?>
<script type="text/javascript" src="<?php echo get_file('xmlhttprequest.js') ?>"></script>
<script type="text/javascript" src="<?php echo get_file('util.js') ?>"></script>
<script type="text/javascript" src="<?php echo get_file('carousel.js') ?>"></script>
<script type="text/javascript">
 var img=<?php echo $img ?>;
 var pos=<?php echo $pos ?>;
 var carousel_size=<?php echo $carousel_size ?>;
 var len=<?php echo $len ?>;
</script>
</head>

<body>

<div id="wrap" class="carousel">

<div id="path" class="iconbox">
<a id="download" href="?dl&amp;img=<?php echo $img ?>">download</a>
<?php echo $dirs->path_links() ?>
<?php switcher('c') ?>
</div>

<table id="header"><tbody><tr><td>
  <h1><?php echo $title ?></h1>
</td><td class="bottom_right">
  <h2><?php echo $album ?></h2>
</td></tr></tbody></table>

<div id="main">
<a href="<?php echo '?d=s&amp;img='.$img ?>">
<img <?php $ir=$imagefiles[$img]->resized(2); $ir->ehtml() ?> />
</a>

<?php

para_caption($imagefiles[$img],$img);
if(intval($options->exif) && strlen($imagefiles[$img]->exif))
    echo '<p class="exif">'.$imagefiles[$img]->exif."</p>\n";
if(intval($options->comments))
    div_comments($imagefiles[$img]);

?>

</div>

<div id="browser">

<?php if($len>$carousel_size): ?>
    <form style="display:none" name="carousel" method="POST">
    <input type="hidden" name="pos" value="<?php echo $pos?>" />
    </form>
    <button id="more_up" onmousedown="carousel_up(this)" onmouseup="scr_off()">more</button>
<?php endif;

for($i=0; $i<$carousel_size; $i++)
{
  div_carousel_thumb( ($pos+$i) % $len, $imagefiles,$img );
}

if($len>$carousel_size): ?>
    <button id="more_down" onmousedown="carousel_down(this)" onmouseup="scr_off()">more</button>
    <?php
    for($i=1; $i<$len; $i++)
    {
      if($pos-$i >= 0)
          div_carousel_thumb($pos-$i,$imagefiles,$img,FALSE);
      if($pos+$carousel_size+$i-1 < $len)
          div_carousel_thumb($pos+$carousel_size+$i-1,$imagefiles,$img,FALSE);
    }
endif;

?>

</div> <!-- carousel -->

<?php status() ?>

</div> <!-- wrap -->

</body>
</html>
<?php } // doc_carousel() ------------------------------------------------------

?>
