<?php // doc_latest.php

function all_comments(&$comments)
{
  $img_dirs=array('.');
  $exa_dirs=array();
  // Find all exa_dirs
  while(count($img_dirs))
  {
    $imgdir=array_shift($img_dirs);
    if($dhandle=opendir($imgdir))
    {
      while(FALSE !== ($fname=readdir($dhandle)))
      {
        if('.'==substr($fname,0,1))
            continue;
        $path=$imgdir.'/'.$fname;
        if('_exa'==$fname)
            $exa_dirs[]=$path;
        elseif(is_dir($path) && is_readable($path))
            $img_dirs[]=$path;
      } // end while
      closedir($dhandle);
    }
  }
  // Find all comment dirs.
  $cmt_dirs=array();
  foreach($exa_dirs as $exadir)
  {
    if($dhandle=opendir($exadir))
    {
      while(FALSE !== ($fname=readdir($dhandle)))
      {
        if('.'==substr($fname,0,1))
            continue;
        $cmtdir=$exadir.'/'.$fname.'/comments';
        if(is_dir($cmtdir) && is_readable($cmtdir))
            $cmt_dirs[]=$cmtdir;
      } // end while
      closedir($dhandle);
    }
  }
  // Find all comments.
  foreach($cmt_dirs as $cmtdir)
  {
    if($dhandle=opendir($cmtdir))
    {
      while(FALSE !== ($fname=readdir($dhandle)))
      {
        if('.'==substr($fname,0,1))
            continue;
        $cmt=$cmtdir.'/'.$fname;
        if(is_file($cmt) && is_readable($cmt))
            $comments[$fname]=$cmt;
      } // end while
      closedir($dhandle);
    }
  }
  // Sort by comment ID (i.e. by timestamp).
  ksort($comments);
}

function tr_comment(&$c)
{
  global $options,$is_admin;
  if($is_admin)
  {
    $lon='<label for="'.$c->id.'">';
    $loff='</label>';
  }
  else
  {
    $lon='';
    $loff='';
  }
  ?>

  <tr class="comment" id="tr_<?php echo $c->id ?>">
  <td class="square">
   <a href="<?php echo $c->link() ?>"><img width="75" height="75" src="<?php echo $c->square() ?>" /></a>
  </td>
  <td>
   <p><?php echo $lon.$c->text.$loff ?></p>
   <p class="by"><?php echo $lon ?>posted by <span class="author"><?php echo $c->author ?></span>
    on <?php echo date($options->date_format,$c->time).$loff ?></p></td>
  <?php if($is_admin): ?><td>
   <input style="width:16px;height:16px" type="checkbox" id="<?php
    echo $c->id ?>" name="cpaths[]" value="<?php echo hsc($c->path) ?>" /></td>
  <?php endif ?>
  </tr>
  
  <?php
}

function doc_latest()
{
  global $dirs,$is_admin;
  $comments=array();
  all_comments($comments);
  $comments=array_reverse(array_values($comments));
  $paged=new Paged(50,count($comments));

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Latest Comments &laquo; <?php echo hsc($dirs->path()) ?></title>
<link rel="stylesheet" href="<?php echo get_file('exa.css') ?>" type="text/css" />
<?php load_theme() ?>
</head>

<body>

<div id="wrap" class="latest">

<div id="path"><?php echo $dirs->path_links(TRUE) ?></div>

<?php
  global $admin_message_text;
  echo $admin_message_text;
?>

<div id="header">
<h1>Latest Comments</h1>
<h2><?php echo $dirs->path() ?></h2>
</div>

<form method="POST" action="?d=l" id="main">
<input type="hidden" name="do" value="delcomments" />

<table><tbody>
<?php

if(count($comments))
{
  if($is_admin)
      $submit='<tr><th colspan="3"><input type="submit" value="delete" /></th></tr>'."\n";
  echo $submit;
  for($i=$paged->begin(); $i<$paged->end(); $i++)
  {
    $cmt=new Comment($comments[$i]);
    tr_comment($cmt);
  }
  echo $submit;
}
else
{
  echo '<tr><td>No comments</td></tr>';
}

?>
</tbody></table>
</form> <!-- main -->

<?php $paged->index('?d=l&amp;') ?>
<?php status() ?>

</div> <!-- wrap -->

</body>
</html>
<?php } // doc_latest() --------------------------------------------------------

?>
