<?php // doc_single.php

function doc_single(&$imagefiles)
{
  assert_img();
  global $dirs,$img,$isize,$options;

  $len=count($imagefiles);

  $title=nice($imagefiles[$img]->name);
  $album=basename(getcwd());

  $prev=normalize($img+$len-1,$len);
  $next=normalize($img+$len+1,$len);

  $on_tmpl='class="on" href="?d=s&amp;img=%s&amp;isize=%s"';
  $off='class="off" href="#"';
  if($isize>0)
    $smaller=sprintf($on_tmpl,$img,$isize-1);
  else
    $smaller=$off;

  if($isize<5)
    $bigger=sprintf($on_tmpl,$img,$isize+1);
  else
    $bigger=$off;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title><?php echo $title.' &laquo; '.hsc($dirs->path()) ?></title>
<link rel="stylesheet" href="<?php echo get_file('exa.css') ?>" type="text/css" />
<?php load_theme() ?>
<script type="text/javascript" src="<?php echo get_file('xmlhttprequest.js') ?>"></script>
<script type="text/javascript" src="<?php echo get_file('util.js') ?>"></script>
<script type="text/javascript" src="<?php echo get_file('slideshow.js') ?>"></script>
<script type="text/javascript"><!--
 var ss=new SlideShow(<?php
   echo $img.','.$len.','.$isize.','.intval($options->slideshow_delay) ?>);
<?php if($_GET['ss']) echo ' window.onload=function(){ss.do_play();}' ?>
//--></script>
</head>

<body>

<div id="wrap">

<div id="path" class="iconbox">
<a id="download" href="?dl&amp;img=<?php echo $img ?>">download</a>
<?php echo $dirs->path_links() ?>
<?php switcher('s') ?>
</div>

<table id="header"><tbody><tr><td>
  <h1 id="title"><?php echo $title ?></h1>
</td><td class="bottom_right iconbox">
  <?php echo img_load('busy') ?>

  <a class="on" id="prev" href="?d=s&amp;img=<?php echo $prev
  ?>" onclick="javascript:ss.do_prev();return false">
    <img title="previous image" src="<?php echo get_file('rew.png')
    ?>" width="16" height="16" alt="rew" /></a>

  <a class="on" id="play" href="javascript:ss.do_play()">
    <img title="play slide show" src="<?php echo get_file('play.png')
    ?>" width="16" height="16" alt="play" /></a>

  <a class="on" id="stop" href="javascript:ss.do_stop()" style="display:none">
    <img title="stop slide show" src="<?php echo get_file('stop.png')
    ?>" width="16" height="16" alt="stop" /></a>

  <a class="on" id="next" href="?d=s&amp;img=<?php echo $next
  ?>" onclick="javascript:ss.do_next();return false">
    <img title="next image" src="<?php echo get_file('fwd.png')
    ?>" width="16" height="16" alt="fwd" /></a>

  &nbsp;&nbsp;

  <a <?php echo $smaller ?> id="smaller" onclick="javascript:ss.do_smaller();return false">
    <img title="smaller" src="<?php echo get_file('smaller.png')
    ?>" width="16" height="16" alt="smaller" /></a>

  <a <?php echo $bigger ?> id="bigger" onclick="javascript:ss.do_bigger();return false">
    <img title="bigger" src="<?php echo get_file('bigger.png')
    ?>" width="16" height="16" alt="bigger" /></a>

</td></tr></tbody></table>

</div> <!-- wrap -->

<div id="single">
<img id="img_<?php echo $img.'_'.$isize
     ?>" <?php $ir=$imagefiles[$img]->resized($isize); $ir->ehtml() ?> />
</div>

<?php status() ?>

</body>
</html>
<?php } // doc_single() --------------------------------------------------------

?>
