# Shell script that emits a PHP function 'get_file()' that embeds the
# files listed as the scripts parameters.

main() {
  header
  ELSEIF='if'
  for F in "$@"
  do
    echo "    $ELSEIF('$F'==\$name)"
    case $F in
      *.css|*.js) # Embed as text
          echo "      fwrite(\$handle,<<<EOFEOF"
          cat $F | sed 's%\\%\\\\%g'
          echo ""
          echo "EOFEOF"
          echo "      );"
          ;;
      *)  # Embed as base64 encoded binary
          echo "      fwrite(\$handle,base64_decode(<<<EOFEOF"
          uuencode -m $F $F | sed '1 d'
          echo "EOFEOF"
          echo "      ));"
          ;;
    esac
    echo "    //###############################################################"
    ELSEIF='elseif'
  done
  footer
}

header() {
cat <<'HERE'
<?php // EMBEDDED.php

/** Calculates the address of the file (in top level _exa directory.
 * Writes the file if it does not already exist. */
function get_file($name)
{
  global $dirs,$options;
  $result=$dirs->top_album().'/'.$name;
  if($options->reload || !file_exists($result))
  {
    $handle=fopen($result,'wb');
HERE
}

footer() {
cat <<'HERE'
    else
        die("Unknown file: $name");
    fclose($handle);
  }
  return htmlspecialchars($result);
}

?>
HERE
}

main "$@"
