<?php // options.php

class Options
{
  var $secret;
  var $passwd='';
  var $comments=1; ///< Allows visitors to leave comments.
  var $exif=1; ///< List EXIF data, where available.
  var $reload=0; ///< Always regenerate 'static' files (for development/upgrade)
  var $top_name='gallery';
  var $home_url=''; ///< If set, generates a link on every page.
  var $home_name='home'; ///< Text for home link.
  var $slideshow_delay=4000;  ///< Min delay between slides, ms.
  var $date_format='j M Y, H:i';
  
  function Options()
  {
    global $dirs, $is_admin;
    $is_admin=false;

    // Read in configuration
    $config_fname=$dirs->top_album().'/config.php';
    if(file_exists($config_fname))
    {
      include $config_fname;
      // Check admin password.
      $passwd='';
      if(array_key_exists('passwd',$_POST))
      {
        $passwd=md5($_POST['passwd'].$this->secret);
        setcookie('exa_passwd',$passwd,0,'/');  
      }
      elseif(array_key_exists('logout',$_GET))
      {
        setcookie('exa_passwd','',time()-100000,'/'); // Unset cookie
        admin_message('Logged out.');
      }
      elseif(array_key_exists('exa_passwd',$_COOKIE))
      {
        $passwd=$_COOKIE['exa_passwd'];
      }
      if(0==strcmp($passwd,$this->passwd))
        $is_admin=true;
      elseif(array_key_exists('passwd',$_POST))
        admin_message('Incorrect password.');
    }
    else
    {
      // Set secret by picking 20 random characters from a list.
      $this->secret='';
      $possible='0123456789abcdfghjkmnpqrstvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_';
      while(strlen($this->secret) < 20)
        $this->secret.=substr($possible, mt_rand(0,strlen($possible)-1), 1);
      $this->exif=function_exists('exif_read_data');
    }
  }
  
  function save()
  {
    global $dirs;
    $config_fname=$dirs->top_album().'/config.php';
    $handle=fopen($config_fname,'wb');
    fwrite($handle,"<?php\n");
    $opts=get_object_vars($this);
    foreach($opts as $k => $v)
        fwrite($handle,sprintf("\$this->%s='%s';\n",$k,$v));
    fwrite($handle,"?>\n");
    fclose($handle);
  }
}
// Construct the global singleton
$options=new Options();

?>
