<?php // paged.php

/** Implements multi-page documents. */
class Paged
{
  function Paged($items_per_page,$num_items,$current_item=0)
  {
    if(array_key_exists('p',$_GET))
      $p=intval($_GET['p']); // page
    else
      $p=intval($current_item/$items_per_page);
    $this->items_per_page=$items_per_page;
    $this->num_items=$num_items;
    $this->num_pages=ceil($num_items/$items_per_page);
    $this->p=minmax(0,$this->num_pages-1,$p);
  }
   /** Starting point for the current page. */
  function begin()
  {
    return( $this->items_per_page * $this->p );
  }
  /** End point for the current page. */
  function end()
  {
    return min( $this->num_items, $this->items_per_page * (1+$this->p) );
  }
  /** Emit a page index. Prev/Next buttons, highlights current page. */
  function index($link)
  {
    $bracket=5;
    $run=$bracket*2+1;
    $spacer=False;
    echo '<div id="pages">';
    if($this->p>0)
      echo '<a href="'.$link.'p='.($this->p-1).'"> &nbsp; &lt; &nbsp;</a>';
    else
      echo '<span class="off"> &nbsp; &lt; &nbsp;</span>';
    for($j=0; $j<$this->num_pages; $j++)
    {
      if($this->p==$j)
      {
        echo '<span class="here">'.($j+1).'</span>';
        $spacer=False;
      }
      elseif($j==0 || $j+1==$this->num_pages || abs($j-$this->p)<$bracket
        || ($this->p<$bracket && $j+1<$run)
        || ($this->p+$bracket>=$this->num_pages && $j+$run-1>=$this->num_pages) )
      {
        echo '<a href="'.$link.'p='.$j.'">'.($j+1).'</a>';
        $spacer=False;
      }
      elseif(!$spacer)
      {
        echo '...';
        $spacer=True;
      }
    }
    if($this->p+1<$this->num_pages)
      echo '<a href="'.$link.'p='.($this->p+1).'">&nbsp; &gt; &nbsp; </a>';
    else
      echo '<span class="off">&nbsp; &gt; &nbsp; </span>';
    echo '</div>';
  }
}

?>
